Summary: PDFtk, The PDF Toolkit
Name: pdftk
Version: 2.02
Release: 2%{?dist}
License: GPL
Group: Applications/Publishing
URL: http://www.pdftk.com

# Can't get debug to work.  Can't get build id to work.
%define debug_package %{nil}

# Based on pdflabs source RPM.
#Packager: Sid Steward
#Vendor: Steward and Lee, LLC, http://www.pdflabs.com
Packager: Thomas Bennet
Vendor: Thomas Bennet

%define mainver 2.02

# Build area.  Several things placed under this.
%define buildarea %{name}-%{mainver}
%define distarea %{buildarea}-%{release}

# Bunch of names and versions used in building the compiler
%define gcc_ver 6.5.0
%define gcc_pkg gcc6-%{gcc_ver}
%define base_gcc gcc-%{gcc_ver}
%define base_jar fastjar-0.98
%define base_isl isl-0.16.1
%define base_mpfr mpfr-2.4.2
%define base_gmp gmp-4.3.2
%define base_mpc mpc-0.8.1
%define base_6mode gcc6mode-0.1

%define src_gcc %{base_gcc}.tar.xz
%define scr_jar %{base_jar}.tar.gz
%define src_isl %{base_isl}.tar.bz2
%define src_mpfr %{base_mpfr}.tar.xz
%define src_gmp %{base_gmp}.tar.bz2
%define src_mpc %{base_mpc}.tar.gz
%define src_6mode %{base_6mode}.tgz
%define src_ecj ecj-latest.jar

# Where the compiler stuff ends up.
%define gcc_dst %{_usr}/gcc650
%define gcc_ecj %{gcc_dst}/share/java/ecj.jar

Requires: gcc6-libgcj

%package -n gcc6
Summary: GCC used to build PDFtk
Version: %{gcc_ver}
Group: Development/Languages
Requires: gcc6-libgcj binutils glibc-headers glibc-devel

%package -n gcc6-libgcj
Version: %{gcc_ver}
Summary: Gcj libraries needed to run PDFtk
Group: Development/Languages

Source: http://www.pdflabs.com/tools/pdftk-the-pdf-toolkit/pdftk-%{mainver}-src.zip
Source1: %{src_gcc}
Source2: %{scr_jar}
Source3: %{src_isl}
Source4: %{src_mpfr}
Source5: %{src_gmp}
Source6: %{src_mpc}
Source7: %{src_ecj}
Source8: %{src_6mode}

BuildRoot: %{_tmppath}/%{name}-%{mainver}-%{release}-root

BuildRequires: gcc zlib-devel

%description
If PDF is electronic paper, then pdftk is an electronic staple-remover,
hole-punch, binder, secret-decoder-ring, and X-Ray-glasses. Pdftk is a simple
tool for doing everyday things with PDF documents. Use it to:

   * Merge PDF Documents or Collate PDF Page Scans
   * Split PDF Pages into a New Document
   * Rotate PDF Documents or Pages
   * Decrypt Input as Necessary (Password Required)
   * Encrypt Output as Desired
   * Fill PDF Forms with X/FDF Data and/or Flatten Forms
   * Generate FDF Data Stencils from PDF Forms
   * Apply a Background Watermark or a Foreground Stamp
   * Report PDF Metrics, Bookmarks and Metadata
   * Add/Update PDF Bookmarks or Metadata
   * Attach Files to PDF Pages or the PDF Document
   * Unpack PDF Attachments
   * Burst a PDF Document into Single Pages
   * Uncompress and Re-Compress Page Streams
   * Repair Corrupted PDF (Where Possible)

%description -n gcc6-libgcj
Just enough of the gcj libraries from %{gcc_ver} to run pdftk. 

%description -n gcc6
Version %{gcc_ver} of gcc, including C, C++ and Java (gcj) compilers
needed to compile pdftk.  This is what is built in order to compile
pdftk, less the few library files needed to support execution of
pdftk, which are in the package gcc6-libgcj.  Add this package if you
want to use that version of gcc, g++ and gcj.  This package is
installed separately from the primary gcc package, in %{gcc_dst}.  You
may want to add this directory to your command path to use the
installed executables.

This package is not required to run pdftk.

%prep
%setup -c -n %{buildarea}
%setup -D -n %{buildarea} -T -a 1
cd %{_builddir}/%{buildarea}/%{base_gcc}
tar fx %{_sourcedir}/%{src_isl}; mv %{base_isl} isl
tar fx %{_sourcedir}/%{src_mpfr}; mv %{base_mpfr} mpfr
tar fx %{_sourcedir}/%{src_gmp}; mv %{base_gmp} gmp
tar fx %{_sourcedir}/%{src_mpc}; mv %{base_mpc} mpc
%setup -D -n %{buildarea} -T -a 2
chmod a-x %{_builddir}/%{buildarea}/%{name}-%{mainver}-dist/license_gpl_pdftk/*.{txt,rtf}
chmod a-x %{_builddir}/%{buildarea}/%{name}-%{mainver}-dist/license_gpl_pdftk/reference/*
chmod a-x %{_builddir}/%{buildarea}/%{name}-%{mainver}-dist/license_gpl_pdftk/third_party/*
%setup -D -n %{buildarea} -T -a 8

%build
# This doesn't work.  Not sure why.  That's why I disabled the debug.
export LDFLAGS=-Wl,--build-id

# Oh brother.  Build the compiler.
mkdir %{_builddir}/%{buildarea}/gccbuild
cd %{_builddir}/%{buildarea}/gccbuild
../%{base_gcc}/configure --prefix=%{_builddir}/%{buildarea}/gcc --enable-languages=c,c++,java --without-x --disable-multilib --with-ecj-jar=%{gcc_ecj}
%{__make}
%{__make} install
export PATH=%{_builddir}/%{buildarea}/gcc/bin:$PATH

# Shortcut for debugging.
#cd %{_builddir}/%{buildarea}
#tar zfx %{_topdir}/gccshortcut.tgz
#export PATH=%{_builddir}/%{buildarea}/gcc/bin:$PATH

# Build the fastjar utility.
cd %{_builddir}/%{buildarea}/%{base_jar}
./configure --prefix=%{_builddir}/%{buildarea}
%{__make}
%{__make} install
export PATH=%{_builddir}/%{buildarea}/bin:$PATH

# Prepare to build the tool with this really odd gcj tweak.  This allows
# it to run where it is, despite the --with-ecj-jar config option that makes it
# work after we install it.
cd %{_builddir}/%{buildarea}/gcc/libexec/gcc/*/*
mv ecj1 ecj1.prod
cat > ecj1 <<EOF
#!/usr/bin/sh
%{_builddir}/%{buildarea}/gcc/bin/gij -cp %{_sourcedir}/%{src_ecj} org.eclipse.jdt.internal.compiler.batch.GCCMain \${1+"\$@"}
EOF
chmod +x ecj1

# Okay.  Now we'll try to build the tool.
cd %{_builddir}/%{buildarea}/%{name}-%{mainver}-dist/pdftk
export -n CLASSPATH
export LD_LIBRARY_PATH=%{_builddir}/%{buildarea}/gcc/lib64
%{__make} -f Makefile.Redhat

# Build this little squirt.  It's a convenience in case some fool
# actually installs the gcc6 package.  
cd %{_builddir}/%{buildarea}/%{base_6mode}
%{__make} STDGCCLOC=%{gcc_dst}

%install
%{__rm} -rf %{buildroot}

# Install the tool (pdftk).
%{__install} -Dp -m0755 %{_builddir}/%{buildarea}/%{name}-%{mainver}-dist/pdftk/pdftk %{buildroot}%{_bindir}/pdftk
%{__install} -Dp -m0644 %{_builddir}/%{buildarea}/%{name}-%{mainver}-dist/pdftk.1 %{buildroot}%{_mandir}/man1/pdftk.1
%{__install} -d -m0755 %{buildroot}/%{_docdir}/%{name}-%{mainver}-%{release}
%{__install} -Dp -m0644 -t %{buildroot}/%{_docdir}/%{name}-%{mainver}-%{release} %{_builddir}/%{buildarea}/%{name}-%{mainver}-dist/pdftk.1.html %{_builddir}/%{buildarea}/%{name}-%{mainver}-dist/changelog*
cp -a %{_builddir}/%{buildarea}/%{name}-%{mainver}-dist/license_gpl_pdftk %{buildroot}%{_docdir}/%{name}-%{mainver}-%{release}

# Install Gcc.
(cd %{_builddir}/%{buildarea}/gcc/libexec/gcc/*/*; mv ecj1.prod ecj1)
%{__install} -d %{buildroot}%{_usr}
cp -a %{_builddir}/%{buildarea}/gcc %{buildroot}%{gcc_dst}
%{__install} -Dp -m0644 %{_sourcedir}/%{src_ecj} %{buildroot}%{gcc_ecj}

# So, why doesn't it look in the configured location?
%{__install} -d %{buildroot}%{_datadir}/java
(cd %{buildroot}%{_datadir}/java; ln -s %{gcc_dst}/share/java/libgcj-%{gcc_ver}.jar libgcj.jar; ln -s %{gcc_dst}/share/java/libgcj-tools-%{gcc_ver}.jar libgcj-tools.jar)

# This is a changed environment sort of hack.  Rpmbuild pukes if you don't.
echo "#!/usr/bin/env python2" > %{buildroot}%{gcc_dst}/bin/aot-compile
tail -n +2 %{_builddir}/%{buildarea}/gcc/bin/aot-compile >> %{buildroot}%{gcc_dst}/bin/aot-compile

# The fastjar is installed with the compiler, since it seems to be needed to build pdftk.
# Grepjar comes along for the ride.
%{__install} -p -m0755 -t %{buildroot}%{_bindir} %{_builddir}/%{buildarea}/bin/* 
%{__install} -Dp -m0644 -t %{buildroot}%{_mandir}/man1 %{_builddir}/%{buildarea}/%{base_jar}/*.1
%{__install} -d %{buildroot}/%{_docdir}/%{gcc_pkg}-%{release}
(cd  %{_builddir}/%{buildarea}/%{base_jar}; %{__install} -Dp -m0644 -t %{buildroot}/%{_docdir}/%{gcc_pkg}-%{release} AUTHORS CHANGES ChangeLog COPYING INSTALL NEWS README TODO  *.info *.texi)

# Separate out the gcj-related libraries
%define libgcj_dst lib64-libgcj
mkdir %{buildroot}%{gcc_dst}/%{libgcj_dst}
mv %{buildroot}%{gcc_dst}/lib64/libgcj* %{buildroot}%{gcc_dst}/%{libgcj_dst}

# Though it makes no sense at all, if you install the compiler, gcj compiles don't work unless you do this.
# Apparently, somewhere, the compile doesn't pay attention to the standard loader locations.
(cd %{buildroot}%{gcc_dst}/lib64; cp -s ../%{libgcj_dst}/* .)

# And add this to the default path to use them for pdftk, which is the actual point of all this.
%{__install} -d %{buildroot}/%{_sysconfdir}/ld.so.conf.d
echo %{gcc_dst}/%{libgcj_dst} > %{buildroot}/%{_sysconfdir}/ld.so.conf.d/gcc6-libgcj.conf

# Install the little shell hack for running the full gcc6
cd %{_builddir}/%{buildarea}/%{base_6mode}
%{__make} PREFIX=%{buildroot}/%{_usr} install

%clean
%{__rm} -rf %{buildroot}

%files
%defattr(-, root, root, 0755)
%doc %{_mandir}/man1/pdftk.1*
%doc %{_docdir}/%{distarea}/
%{_bindir}/pdftk

%files -n gcc6
%defattr(-, root, root, 0755)
%{gcc_dst}
%{_bindir}/fastjar
%{_bindir}/grepjar
%{_bindir}/gcc6mode
%{_datadir}/java/libgcj.jar
%{_datadir}/java/libgcj-tools.jar
%doc %{_mandir}/man1/fastjar.1*
%doc %{_mandir}/man1/grepjar.1*
%doc %{_mandir}/man1/gcc6mode.1*
%doc %{_docdir}/gcc6-%{gcc_ver}-%{release}

%files -n gcc6-libgcj
%defattr(-, root, root, 0755)
%{gcc_dst}/%{libgcj_dst}
%{_sysconfdir}/ld.so.conf.d/gcc6-libgcj.conf

%post -n gcc6-libgcj
/sbin/ldconfig

%postun -n gcc6-libgcj
/sbin/ldconfig

%changelog
* Fri May 8 2020 Tom Bennet <bennet@mc.edu>
- Initial package.  Based on pdftk-2.02 package from Sid Steward, but much
- expanded.  Builds the gcc to build pdftk.  The compiler is provided as a
- subpackage, but is not needed (or recommended) to run pdftk.

